<?php

/* 
 * Safely update wp_postmeta table with a new url
 * Author: John
 * Author Url: http://www.kcrnc.com
*/

require_once("../wp-load.php");

global $wpdb;

$old_url = 'your_old_url';
$new_url = 'your_new_url';

$query = "select * from {$wpdb->postmeta} where meta_value like %s";
$where_fields = array('%'.$old_url.'%');
$sql = $wpdb->prepare($query, $where_fields);

$update_post_meta = $wpdb->get_results($sql , ARRAY_A );

$result_count = count($update_post_meta);

echo "<p>Starting Check for: {$old_url} on {$result_count} results</p>";

foreach($update_post_meta as $meta_data){
	
	$original_meta = $meta_data['meta_value'];
	$is_serialized = false;
	
	if(is_serialized($original_meta)){
		$original_meta = unserialize($original_meta);
		$is_serialized = true;
	}
	
	$new_meta =  kcr_process_meta_values($original_meta, $old_url, $new_url);
	
	if($is_serialized){
		$new_meta = serialize($new_meta);
	}
	
	$update_result = $wpdb->update($wpdb->postmeta, array("meta_value"=>$new_meta),array("meta_id"=>$meta_data['meta_id']), array("%s"), array("%d"));

	if($result === false){
		echo "Error Updating {$meta_data['meta_id']}";
		
		if(!empty($wpbd->last_error)){
			echo "Mysql Error: Updating {$wpbd->last_error}";
		}
		echo "<br />";
	}
	else {
		echo "Updated Meta ID :  {$meta_data['meta_id']}<br />";			
	}	
}


function kcr_process_meta_values($meta_values, $old_url, $new_url){

	if(!is_array($meta_values)){
		return str_replace($old_url, $new_url, $meta_values);		
	}

	foreach($meta_values as $meta_key => &$meta_value){	
		$meta_value = kcr_process_meta_values($meta_value, $old_url, $new_url);		
	}

	return $meta_values;

}
